#include "../common_hw/xf86.h"
#include "../common_hw/vga.h"
#include "mga.h"


/*****
typedef struct {
	vgaHWRec std;                          
	unsigned long DAClong;
	unsigned char DACclk[6];
	unsigned char DACreg[sizeof(MGADACregs)];
	unsigned char ExtVga[6];
} vgaMGARec, *vgaMGAPtr;
*****/



vgaMGARec MGAmodes[] = {
{
/* 1024x768 15bpp mode */
    /* std */ {
    /* MiscOut */ 0xef, 
    /* CRTC */ { 0xa5, 0x7f, 0x7f, 0x89, 0x80, 0x8f, 0x35, 0xf5, 0x0,
                0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0x22, 0xff,
	        0x80, 0x0, 0xff, 0x36, 0xc3, 0xff},

    /* Sequencer */  { 0x3, 0x1, 0xf, 0x0, 0xe}, 

    /* Graphics */ { 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x5, 0xf, 0xff},

    /* Attribute */ {0x0, 0x1, 0x2, 0x3, 0x4, 0x5, 0x6, 0x7, 0x8, 0x9,
		 0xa, 0xb, 0xc, 0xd, 0xe, 0xf, 0x41, 0xff, 0xf, 0x0, 0x0},

    /* DAC */ {0x0, 0x0, 0x0,
      // 0x3f <repeats 765 times>
		}, 

    /* NoClock */   0x5, 

    /* FontInfo1 */ 0x0, 

    /* FontInfo2 */ 0x0, 

    /* TextInfo */  0x0
  },

 
  /* DAClong */ 0x5f2c1100,

  /* DACclk */ {0xe8, 0x1c, 0xb1, 0xf1, 0x3d, 0xf2},

  /* DACreg */ {0x7, 0x4, 0x54, 0x15, 0x0, 0x3, 0x2c, 0x0, 0x15, 0xff,
	        0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0, 0x38,
                0x0, 0x0},

  /* ExtVga */ {0x0, 0x0, 0x0, 0x81, 0x0, 0x0}
 
},

/* 1280 x 1024 15bpp mode */
{


    /* std = */ {
    /* MiscOutReg = */ 0xef, 
    /* CRTC = */ {0xcb, 0x9f, 0x9f, 0x8f, 0xa0, 0xd, 
      0x26, 0x5a, 0x0, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x25, 0xff, 
      0xa0, 0x0, 0xff, 0x27, 0xc3, 0xff}, 
    /* Sequencer = */ {0x3, 0x1, 0xf, 0x0, 
      0xe}, 
    /* Graphics = */ {0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x5, 0xf, 0xff}, 
    /* Attribute = */ {0x0, 0x1, 0x2, 0x3, 0x4, 0x5, 0x6, 0x7, 0x8,
		0x9, 0xa, 0xb, 0xc, 0xd, 0xe, 0xf, 0x41, 0xff, 0xf, 0x0, 0x0}, 
    /* DAC = */ {0x0, 0x0, 0x0, 0x3f /* repeats 765 */ },
    /* NoClock = */ 0x4, 
    /* FontInfo1 = */ 0x0, 
    /* FontInfo2 = */ 0x0, 
    /* TextInfo = */ 0x0}, 
    /* DAClong = */ 0x5f2c1100, 
    /* DACclk = */ {0xf0, 0x2d, 0xb0, 0xf1, 0x3d, 0xf1}, 
    /* DACreg = */ {0x7, 0x4, 0x54, 0x15, 0x0, 0x3, 
	    	    0x2c, 0x0, 0x15, 0xff, 0xff, 0xff, 0xff, 0xff, 
                    0xff, 0xff, 0xff, 0x0, 0x38, 0x0, 0x0}, 
    /* ExtVga = */ {0x0, 0x40, 0x21, 0x81, 0x0, 0x0}
},

/* 1600 x 1200 15bpp mode */
{
    /* std = */ {
    /* MiscOutReg = */ 0xef, 
    /* CRTC = */ {0xf5, 0xc7, 0xc7, 0x99, 0xcb, 0x99, 
      0xcb, 0x10, 0x0, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xb1, 0x29, 0xaf, 
      0xc8, 0x0, 0xaf, 0xcc, 0xc3, 0xff}, 
    /* Sequencer = */ {0x3, 0x1, 0xf, 0x0, 0xe}, 
    /* Graphics = */ {0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x5, 0xf, 0xff}, 
    /* Attribute = */ {0x0, 0x1, 0x2, 0x3, 0x4, 0x5, 0x6, 0x7, 0x8,
		       0x9, 0xa, 0xb, 
	               0xc, 0xd, 0xe, 0xf, 0x41, 0xff, 0xf, 0x0, 0x0}, 
    /* DAC = */ {0x0, 0x0, 0x0, 0x3f /*<repeats 765 times>*/ }, 
    /* NoClock = */ 0x5, 
    /* FontInfo1 = */ 0x0, 
    /* FontInfo2 = */ 0x0, 
    /* TextInfo = */ 0x0}, 
    /* DAClong = */ 0x5f2c1100, 
    /* DACclk = */ {0xe8, 0x1c, 0xb0, 0xf1, 0x3d, 0xf1}, 
    /* DACreg = */ {0x7, 0x4, 0x54, 0x15, 0x0, 0x0, 
       0x2c, 0x0, 0x15, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0, 
       0x38, 0x0, 0x0}, 
    /* ExtVga = */ {0x0, 0x40, 0x2d, 0x81, 0x0, 0x0}
}

};

vgaMGAG200Rec MGAmodesG200[] = { /* start of whole mode array */

#define MODE1

#ifdef MODE1
{ /* start of 1024x768 15bpp mode */

    /* std */ {

/* MiscOutReg = */ 0x2f, 

/* CRTC = */ {0xa5, 0x7f,
0x7f, 0x89, 0x80, 0x8f, 0x35, 0xf5, 0x0, 0x60, 0x0, 0x0, 0x0, 0x0,
0x3f, 0xff, 0xf, 0x22, 0xff, 0x80, 0x0, 0xff, 0x36, 0xc3, 0xff},

/* Sequencer = */ {0x3, 0x1, 0xf, 0x0, 0xe}, 

/* Graphics = */ {0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x5, 0xf, 0xff},

/* Attribute = */ {0x0, 0x1, 0x2, 0x3, 0x4, 0x5, 0x6, 0x7, 0x8, 0x9,
0xa, 0xb, 0xc, 0xd, 0xe, 0xf, 0x41, 0xff, 0xf, 0x0, 0x0},

/* DAC = */ {0x0, 0x0, 0x0, 0x8, 0x8, 0x8, 0x10, 0x10, 0x10,
0x18, 0x18, 0x18, 0x20, 0x20, 0x20, 0x28, 0x28, 0x28, 0x30, 0x30,
0x30, 0x38, 0x38, 0x38, 0x40, 0x40, 0x40, 0x48, 0x48, 0x48, 0x50,
0x50, 0x50, 0x58, 0x58, 0x58, 0x60, 0x60, 0x60, 0x68, 0x68, 0x68,
0x70, 0x70, 0x70, 0x78, 0x78, 0x78, 0x80, 0x80, 0x80, 0x88, 0x88,
0x88, 0x90, 0x90, 0x90, 0x98, 0x98, 0x98, 0xa0, 0xa0, 0xa0, 0xa8,
0xa8, 0xa8, 0xb0, 0xb0, 0xb0, 0xb8, 0xb8, 0xb8, 0xc0, 0xc0, 0xc0,
0xc8, 0xc8, 0xc8, 0xd0, 0xd0, 0xd0, 0xd8, 0xd8, 0xd8, 0xe0, 0xe0,
0xe0, 0xe8, 0xe8, 0xe8, 0xf0, 0xf0, 0xf0, 0xf8, 0xf8, 0xf8, 0x0, 0x0,
0x0, 0x8, 0x8, 0x8, 0x10, 0x10, 0x10, 0x18, 0x18, 0x18, 0x20, 0x20,
0x20, 0x28, 0x28, 0x28, 0x30, 0x30, 0x30, 0x38, 0x38, 0x38, 0x40,
0x40, 0x40, 0x48, 0x48, 0x48, 0x50, 0x50, 0x50, 0x58, 0x58, 0x58,
0x60, 0x60, 0x60, 0x68, 0x68, 0x68, 0x70, 0x70, 0x70, 0x78, 0x78,
0x78, 0x80, 0x80, 0x80, 0x88, 0x88, 0x88, 0x90, 0x90, 0x90, 0x98,
0x98, 0x98, 0xa0, 0xa0, 0xa0, 0xa8, 0xa8, 0xa8, 0xb0, 0xb0, 0xb0,
0xb8, 0xb8, 0xb8, 0xc0, 0xc0, 0xc0, 0xc8, 0xc8, 0xc8, 0xd0, 0xd0,
0xd0, 0xd8, 0xd8, 0xd8, 0xe0, 0xe0, 0xe0, 0xe8, 0xe8, 0xe8, 0xf0,
0xf0, 0xf0, 0xf8, 0xf8, 0xf8, 0x0, 0x0, 0x0, 0x8, 0x8, 0x8, 0x10,
0x10, 0x10, 0x18, 0x18, 0x18, 0x20, 0x20, 0x20, 0x28, 0x28, 0x28,
0x30, 0x30, 0x30, 0x38, 0x38, 0x38, 0x40, 0x40, 0x40, 0x48, 0x48,
0x48, 0x50, 0x50, 0x50, 0x58, 0x58, 0x58, 0x60, 0x60, 0x60, 0x68,
0x68, 0x68, 0x70, 0x70, 0x70, 0x78, 0x78, 0x78, 0x80, 0x80, 0x80,
0x88, 0x88, 0x88, 0x90, 0x90, 0x90, 0x98, 0x98, 0x98, 0xa0, 0xa0,
0xa0, 0xa8, 0xa8, 0xa8, 0xb0, 0xb0, 0xb0, 0xb8, 0xb8, 0xb8, 0xc0,
0xc0, 0xc0, 0xc8, 0xc8, 0xc8, 0xd0, 0xd0, 0xd0, 0xd8, 0xd8, 0xd8,
0xe0, 0xe0, 0xe0, 0xe8, 0xe8, 0xe8, 0xf0, 0xf0, 0xf0, 0xf8, 0xf8,
0xf8, 0x0, 0x0, 0x0, 0x8, 0x8, 0x8, 0x10, 0x10, 0x10, 0x18, 0x18,
0x18, 0x20, 0x20, 0x20, 0x28, 0x28, 0x28, 0x30, 0x30, 0x30, 0x38,
0x38, 0x38, 0x40, 0x40, 0x40, 0x48, 0x48, 0x48, 0x50, 0x50, 0x50,
0x58, 0x58, 0x58, 0x60, 0x60, 0x60, 0x68, 0x68, 0x68, 0x70, 0x70,
0x70, 0x78, 0x78, 0x78, 0x80, 0x80, 0x80, 0x88, 0x88, 0x88, 0x90,
0x90, 0x90, 0x98, 0x98, 0x98, 0xa0, 0xa0, 0xa0, 0xa8, 0xa8, 0xa8,
0xb0, 0xb0, 0xb0, 0xb8, 0xb8, 0xb8, 0xc0, 0xc0, 0xc0, 0xc8, 0xc8,
0xc8, 0xd0, 0xd0, 0xd0, 0xd8, 0xd8, 0xd8, 0xe0, 0xe0, 0xe0, 0xe8,
0xe8, 0xe8, 0xf0, 0xf0, 0xf0, 0xf8, 0xf8, 0xf8, 0x0, 0x0, 0x0, 0x8,
0x8, 0x8, 0x10, 0x10, 0x10, 0x18, 0x18, 0x18, 0x20, 0x20, 0x20, 0x28,
0x28, 0x28, 0x30, 0x30, 0x30, 0x38, 0x38, 0x38, 0x40, 0x40, 0x40,
0x48, 0x48, 0x48, 0x50, 0x50, 0x50, 0x58, 0x58, 0x58, 0x60, 0x60,
0x60, 0x68, 0x68, 0x68, 0x70, 0x70, 0x70, 0x78, 0x78, 0x78, 0x80,
0x80, 0x80, 0x88, 0x88, 0x88, 0x90, 0x90, 0x90, 0x98, 0x98, 0x98,
0xa0, 0xa0, 0xa0, 0xa8, 0xa8, 0xa8, 0xb0, 0xb0, 0xb0, 0xb8, 0xb8,
0xb8, 0xc0, 0xc0, 0xc0, 0xc8, 0xc8, 0xc8, 0xd0, 0xd0, 0xd0, 0xd8,
0xd8, 0xd8, 0xe0, 0xe0, 0xe0, 0xe8, 0xe8, 0xe8, 0xf0, 0xf0, 0xf0,
0xf8, 0xf8, 0xf8, 0x0, 0x0, 0x0, 0x8, 0x8, 0x8, 0x10, 0x10, 0x10,
0x18, 0x18, 0x18, 0x20, 0x20, 0x20, 0x28, 0x28, 0x28, 0x30, 0x30,
0x30, 0x38, 0x38, 0x38, 0x40, 0x40, 0x40, 0x48, 0x48, 0x48, 0x50,
0x50, 0x50, 0x58, 0x58, 0x58, 0x60, 0x60, 0x60, 0x68, 0x68, 0x68,
0x70, 0x70, 0x70, 0x78, 0x78, 0x78, 0x80, 0x80, 0x80, 0x88, 0x88,
0x88, 0x90, 0x90, 0x90, 0x98, 0x98, 0x98, 0xa0, 0xa0, 0xa0, 0xa8,
0xa8, 0xa8, 0xb0, 0xb0, 0xb0, 0xb8, 0xb8, 0xb8, 0xc0, 0xc0, 0xc0,
0xc8, 0xc8, 0xc8, 0xd0, 0xd0, 0xd0, 0xd8, 0xd8, 0xd8, 0xe0, 0xe0,
0xe0, 0xe8, 0xe8, 0xe8, 0xf0, 0xf0, 0xf0, 0xf8, 0xf8, 0xf8, 0x0, 0x0,
0x0, 0x8, 0x8, 0x8, 0x10, 0x10, 0x10, 0x18, 0x18, 0x18, 0x20, 0x20,
0x20, 0x28, 0x28, 0x28, 0x30, 0x30, 0x30, 0x38, 0x38, 0x38, 0x40,
0x40, 0x40, 0x48, 0x48, 0x48, 0x50, 0x50, 0x50, 0x58, 0x58, 0x58,
0x60, 0x60, 0x60, 0x68, 0x68, 0x68, 0x70, 0x70, 0x70, 0x78, 0x78,
0x78, 0x80, 0x80, 0x80, 0x88, 0x88, 0x88, 0x90, 0x90, 0x90, 0x98,
0x98, 0x98, 0xa0, 0xa0, 0xa0, 0xa8, 0xa8, 0xa8, 0xb0, 0xb0, 0xb0,
0xb8, 0xb8, 0xb8, 0xc0, 0xc0, 0xc0, 0xc8, 0xc8, 0xc8, 0xd0, 0xd0,
0xd0, 0xd8, 0xd8, 0xd8, 0xe0, 0xe0, 0xe0, 0xe8, 0xe8, 0xe8, 0xf0,
0xf0, 0xf0, 0xf8, 0xf8, 0xf8, 0x0, 0x0, 0x0, 0x8, 0x8, 0x8, 0x10,
0x10, 0x10, 0x18, 0x18, 0x18, 0x20, 0x20, 0x20, 0x28, 0x28, 0x28,
0x30, 0x30, 0x30, 0x38, 0x38, 0x38, 0x40, 0x40, 0x40, 0x48, 0x48,
0x48, 0x50, 0x50, 0x50, 0x58, 0x58, 0x58, 0x60, 0x60, 0x60, 0x68,
0x68, 0x68, 0x70, 0x70, 0x70, 0x78, 0x78, 0x78, 0x80, 0x80, 0x80,
0x88, 0x88, 0x88, 0x90, 0x90, 0x90, 0x98, 0x98, 0x98, 0xa0, 0xa0,
0xa0, 0xa8, 0xa8, 0xa8, 0xb0, 0xb0, 0xb0, 0xb8, 0xb8, 0xb8, 0xc0,
0xc0, 0xc0, 0xc8, 0xc8, 0xc8, 0xd0, 0xd0, 0xd0, 0xd8, 0xd8, 0xd8,
0xe0, 0xe0, 0xe0, 0xe8, 0xe8, 0xe8, 0xf0, 0xf0, 0xf0, 0xf8, 0xf8,
0xf8}, 

/* NoClock = */ 0x5, 

/* FontInfo1 = */ 0x0, 
/* FontInfo2 = */ 0x0, 
/* TextInfo = */ 0x0
}, 

/* DAClong = */ 0x6007cd21, 

/* DACreg = */ {0x0, 0x0, 0x0, 0x0, 0xff, 0x1f, 0x3, 0xff, 0xff, 0xff,
0xff, 0xff, 0x0, 0x0, 0x0, 0xfe, 0x0, 0x0, 0x0, 0x7f, 0xff, 0xf, 0x7f,
0xc5, 0x3, 0x1, 0x9, 0x7f, 0xff, 0x20, 0x1f, 0x20, 0x0, 0x0, 0x0, 0x0,
0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0x3, 0x26, 0x19, 0x40, 0x0,
0x6f, 0x0, 0x62, 0xfb, 0x6b, 0x2, 0xeb, 0x0, 0xa1, 0x0, 0xff, 0x8c,
0xdf, 0x2, 0xeb, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0xc5, 0x0, 0x0,
0x0, 0x40, 0x3, 0x18, 0x11, 0x40},

/* ExtVga = */ {0x0, 0x0, 0x0, 0x81, 0x0, 0x0}
} /* end of 1024x768 15bpp array */
#endif /* MODE1 */

#ifdef MODE2
{ /* start of 1024x768 15bpp mode */
/* std */ {
/* MiscOutReg = */ 0x2f, 

/* CRTC = */ {0xf, 0xc7, 0xc7, 0x93, 0xdf, 0x7, 
      0xe6, 0x10, 0x0, 0x40, 0x0, 0x0, 0x0, 0x0, 0x3f, 0xff, 0xb1, 0x24, 0xaf, 
      0xc8, 0x0, 0xaf, 0xe7, 0xc3, 0xff}, 

/* Sequencer = */ {0x3, 0x1, 0xf, 0x0, 0xe}, 

/* Graphics = */ {0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x5, 0xf, 0xff}, 

/* Attribute = */ {0x0, 0x1, 0x2, 0x3, 0x4, 0x5, 0x6, 0x7, 0x8, 0x9, 0xa, 0xb, 
      0xc, 0xd, 0xe, 0xf, 0x41, 0xff, 0xf, 0x0, 0x0}, 

/* DAC = */ {0x0, 0x0, 0x0, 
      0x8, 0x8, 0x8, 0x10, 0x10, 0x10, 0x18, 0x18, 0x18, 0x20, 0x20, 0x20, 
      0x28, 0x28, 0x28, 0x30, 0x30, 0x30, 0x38, 0x38, 0x38, 0x40, 0x40, 0x40, 
      0x48, 0x48, 0x48, 0x50, 0x50, 0x50, 0x58, 0x58, 0x58, 0x60, 0x60, 0x60, 
      0x68, 0x68, 0x68, 0x70, 0x70, 0x70, 0x78, 0x78, 0x78, 0x80, 0x80, 0x80, 
      0x88, 0x88, 0x88, 0x90, 0x90, 0x90, 0x98, 0x98, 0x98, 0xa0, 0xa0, 0xa0, 
      0xa8, 0xa8, 0xa8, 0xb0, 0xb0, 0xb0, 0xb8, 0xb8, 0xb8, 0xc0, 0xc0, 0xc0, 
      0xc8, 0xc8, 0xc8, 0xd0, 0xd0, 0xd0, 0xd8, 0xd8, 0xd8, 0xe0, 0xe0, 0xe0, 
      0xe8, 0xe8, 0xe8, 0xf0, 0xf0, 0xf0, 0xf8, 0xf8, 0xf8, 0x0, 0x0, 0x0, 
      0x8, 0x8, 0x8, 0x10, 0x10, 0x10, 0x18, 0x18, 0x18, 0x20, 0x20, 0x20, 
      0x28, 0x28, 0x28, 0x30, 0x30, 0x30, 0x38, 0x38, 0x38, 0x40, 0x40, 0x40, 
      0x48, 0x48, 0x48, 0x50, 0x50, 0x50, 0x58, 0x58, 0x58, 0x60, 0x60, 0x60, 
      0x68, 0x68, 0x68, 0x70, 0x70, 0x70, 0x78, 0x78, 0x78, 0x80, 0x80, 0x80, 
      0x88, 0x88, 0x88, 0x90, 0x90, 0x90, 0x98, 0x98, 0x98, 0xa0, 0xa0, 0xa0, 
      0xa8, 0xa8, 0xa8, 0xb0, 0xb0, 0xb0, 0xb8, 0xb8, 0xb8, 0xc0, 0xc0, 0xc0, 
      0xc8, 0xc8, 0xc8, 0xd0, 0xd0, 0xd0, 0xd8, 0xd8, 0xd8, 0xe0, 0xe0, 0xe0, 
      0xe8, 0xe8, 0xe8, 0xf0, 0xf0, 0xf0, 0xf8, 0xf8, 0xf8, 0x0, 0x0, 0x0, 
      0x8, 0x8, 0x8, 0x10, 0x10, }, 

/* NoClock = */   0x7, 
/* FontInfo1 = */ 0x0, 

/* FontInfo2 = */ 0x0, 
/* TextInfo = */  0x0
   }, 


/* DAClong = */ 0x6007cd21, 
/* DACreg = */ {
    0x00, 0x00, 0x00, 0x00, 0xff, 0x1f, 0x03, 0x5f, 0xff, 0xff, 0xff, 0xff, 
    0x00, 0x00, 0x00, 0x9d, 0x00, 0x00, 0x00, 0x1c, 0x01, 0x00, 0x0a, 0x46, 
    0x03, 0x01, 0x09, 0x7d, 0x1f, 0x20, 0x1f, 0x20, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7d, 0x03, 0x26, 0x19, 0x40, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x02, 0x00, 0x00, 0x00, 0x7d, 
    0x00, 0x00, 0x02, 0x02, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46, 
    0x00, 0x00, 0x00, 0x40, 0x1, 0xd, 0x18, 0x40
}, 

/* ExtVga = */ {0x0, 0x1, 0x2d, 0x81, 0x0, 0x0}
} /* end of 1024 x 768 1bpp mode */
#endif /* MODE2 */


#ifdef MODE3
    /* std */ { 
/* MiscOutReg = */ 0x2f, 

/* CRTC = */ {0xa5, 0x7f,
0x7f, 0x89, 0x80, 0x8f, 0x35, 0xf5, 0x0, 0x60, 0x0, 0x0, 0x0, 0x0,
0x00, 0x00, 0xf, 0x22, 0xff, 0x80, 0x0, 0xff, 0x36, 0xc3, 0xff},

/* Sequencer = */ {0x0, 0x1, 0xf, 0x0, 0xe}, 

/* Graphics = */ {0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x5, 0xf, 0xff},

/* Attribute = */ {0x0, 0x1, 0x2, 0x3, 0x4, 0x5, 0x6, 0x7, 0x8, 0x9,
    0xa, 0xb, 0xc, 0xd, 0xe, 0xf, 0x41, 0xff, 0xf, 0x0, 0x0},

/* DAC = */ {0x0, 0x0, 0x0, 0x8, 0x8, 0x8, 0x10, 0x10, 0x10,
0x18, 0x18, 0x18, 0x20, 0x20, 0x20, 0x28, 0x28, 0x28, 0x30, 0x30,
0x30, 0x38, 0x38, 0x38, 0x40, 0x40, 0x40, 0x48, 0x48, 0x48, 0x50,
0x50, 0x50, 0x58, 0x58, 0x58, 0x60, 0x60, 0x60, 0x68, 0x68, 0x68,
0x70, 0x70, 0x70, 0x78, 0x78, 0x78, 0x80, 0x80, 0x80, 0x88, 0x88,
0x88, 0x90, 0x90, 0x90, 0x98, 0x98, 0x98, 0xa0, 0xa0, 0xa0, 0xa8,
0xa8, 0xa8, 0xb0, 0xb0, 0xb0, 0xb8, 0xb8, 0xb8, 0xc0, 0xc0, 0xc0,
0xc8, 0xc8, 0xc8, 0xd0, 0xd0, 0xd0, 0xd8, 0xd8, 0xd8, 0xe0, 0xe0,
0xe0, 0xe8, 0xe8, 0xe8, 0xf0, 0xf0, 0xf0, 0xf8, 0xf8, 0xf8, 0x0, 0x0,
0x0, 0x8, 0x8, 0x8, 0x10, 0x10, 0x10, 0x18, 0x18, 0x18, 0x20, 0x20,
0x20, 0x28, 0x28, 0x28, 0x30, 0x30, 0x30, 0x38, 0x38, 0x38, 0x40,
0x40, 0x40, 0x48, 0x48, 0x48, 0x50, 0x50, 0x50, 0x58, 0x58, 0x58,
0x60, 0x60, 0x60, 0x68, 0x68, 0x68, 0x70, 0x70, 0x70, 0x78, 0x78,
0x78, 0x80, 0x80, 0x80, 0x88, 0x88, 0x88, 0x90, 0x90, 0x90, 0x98,
0x98, 0x98, 0xa0, 0xa0, 0xa0, 0xa8, 0xa8, 0xa8, 0xb0, 0xb0, 0xb0,
0xb8, 0xb8, 0xb8, 0xc0, 0xc0, 0xc0, 0xc8, 0xc8, 0xc8, 0xd0, 0xd0,
0xd0, 0xd8, 0xd8, 0xd8, 0xe0, 0xe0, 0xe0, 0xe8, 0xe8, 0xe8, 0xf0,
0xf0, 0xf0, 0xf8, 0xf8, 0xf8, 0x0, 0x0, 0x0, 0x8, 0x8, 0x8, 0x10,
0x10, 0x10, 0x18, 0x18, 0x18, 0x20, 0x20, 0x20, 0x28, 0x28, 0x28,
0x30, 0x30, 0x30, 0x38, 0x38, 0x38, 0x40, 0x40, 0x40, 0x48, 0x48,
0x48, 0x50, 0x50, 0x50, 0x58, 0x58, 0x58, 0x60, 0x60, 0x60, 0x68,
0x68, 0x68, 0x70, 0x70, 0x70, 0x78, 0x78, 0x78, 0x80, 0x80, 0x80,
0x88, 0x88, 0x88, 0x90, 0x90, 0x90, 0x98, 0x98, 0x98, 0xa0, 0xa0,
0xa0, 0xa8, 0xa8, 0xa8, 0xb0, 0xb0, 0xb0, 0xb8, 0xb8, 0xb8, 0xc0,
0xc0, 0xc0, 0xc8, 0xc8, 0xc8, 0xd0, 0xd0, 0xd0, 0xd8, 0xd8, 0xd8,
0xe0, 0xe0, 0xe0, 0xe8, 0xe8, 0xe8, 0xf0, 0xf0, 0xf0, 0xf8, 0xf8,
0xf8, 0x0, 0x0, 0x0, 0x8, 0x8, 0x8, 0x10, 0x10, 0x10, 0x18, 0x18,
0x18, 0x20, 0x20, 0x20, 0x28, 0x28, 0x28, 0x30, 0x30, 0x30, 0x38,
0x38, 0x38, 0x40, 0x40, 0x40, 0x48, 0x48, 0x48, 0x50, 0x50, 0x50,
0x58, 0x58, 0x58, 0x60, 0x60, 0x60, 0x68, 0x68, 0x68, 0x70, 0x70,
0x70, 0x78, 0x78, 0x78, 0x80, 0x80, 0x80, 0x88, 0x88, 0x88, 0x90,
0x90, 0x90, 0x98, 0x98, 0x98, 0xa0, 0xa0, 0xa0, 0xa8, 0xa8, 0xa8,
0xb0, 0xb0, 0xb0, 0xb8, 0xb8, 0xb8, 0xc0, 0xc0, 0xc0, 0xc8, 0xc8,
0xc8, 0xd0, 0xd0, 0xd0, 0xd8, 0xd8, 0xd8, 0xe0, 0xe0, 0xe0, 0xe8,
0xe8, 0xe8, 0xf0, 0xf0, 0xf0, 0xf8, 0xf8, 0xf8, 0x0, 0x0, 0x0, 0x8,
0x8, 0x8, 0x10, 0x10, 0x10, 0x18, 0x18, 0x18, 0x20, 0x20, 0x20, 0x28,
0x28, 0x28, 0x30, 0x30, 0x30, 0x38, 0x38, 0x38, 0x40, 0x40, 0x40,
0x48, 0x48, 0x48, 0x50, 0x50, 0x50, 0x58, 0x58, 0x58, 0x60, 0x60,
0x60, 0x68, 0x68, 0x68, 0x70, 0x70, 0x70, 0x78, 0x78, 0x78, 0x80,
0x80, 0x80, 0x88, 0x88, 0x88, 0x90, 0x90, 0x90, 0x98, 0x98, 0x98,
0xa0, 0xa0, 0xa0, 0xa8, 0xa8, 0xa8, 0xb0, 0xb0, 0xb0, 0xb8, 0xb8,
0xb8, 0xc0, 0xc0, 0xc0, 0xc8, 0xc8, 0xc8, 0xd0, 0xd0, 0xd0, 0xd8,
0xd8, 0xd8, 0xe0, 0xe0, 0xe0, 0xe8, 0xe8, 0xe8, 0xf0, 0xf0, 0xf0,
0xf8, 0xf8, 0xf8, 0x0, 0x0, 0x0, 0x8, 0x8, 0x8, 0x10, 0x10, 0x10,
0x18, 0x18, 0x18, 0x20, 0x20, 0x20, 0x28, 0x28, 0x28, 0x30, 0x30,
0x30, 0x38, 0x38, 0x38, 0x40, 0x40, 0x40, 0x48, 0x48, 0x48, 0x50,
0x50, 0x50, 0x58, 0x58, 0x58, 0x60, 0x60, 0x60, 0x68, 0x68, 0x68,
0x70, 0x70, 0x70, 0x78, 0x78, 0x78, 0x80, 0x80, 0x80, 0x88, 0x88,
0x88, 0x90, 0x90, 0x90, 0x98, 0x98, 0x98, 0xa0, 0xa0, 0xa0, 0xa8,
0xa8, 0xa8, 0xb0, 0xb0, 0xb0, 0xb8, 0xb8, 0xb8, 0xc0, 0xc0, 0xc0,
0xc8, 0xc8, 0xc8, 0xd0, 0xd0, 0xd0, 0xd8, 0xd8, 0xd8, 0xe0, 0xe0,
0xe0, 0xe8, 0xe8, 0xe8, 0xf0, 0xf0, 0xf0, 0xf8, 0xf8, 0xf8, 0x0, 0x0,
0x0, 0x8, 0x8, 0x8, 0x10, 0x10, 0x10, 0x18, 0x18, 0x18, 0x20, 0x20,
0x20, 0x28, 0x28, 0x28, 0x30, 0x30, 0x30, 0x38, 0x38, 0x38, 0x40,
0x40, 0x40, 0x48, 0x48, 0x48, 0x50, 0x50, 0x50, 0x58, 0x58, 0x58,
0x60, 0x60, 0x60, 0x68, 0x68, 0x68, 0x70, 0x70, 0x70, 0x78, 0x78,
0x78, 0x80, 0x80, 0x80, 0x88, 0x88, 0x88, 0x90, 0x90, 0x90, 0x98,
0x98, 0x98, 0xa0, 0xa0, 0xa0, 0xa8, 0xa8, 0xa8, 0xb0, 0xb0, 0xb0,
0xb8, 0xb8, 0xb8, 0xc0, 0xc0, 0xc0, 0xc8, 0xc8, 0xc8, 0xd0, 0xd0,
0xd0, 0xd8, 0xd8, 0xd8, 0xe0, 0xe0, 0xe0, 0xe8, 0xe8, 0xe8, 0xf0,
0xf0, 0xf0, 0xf8, 0xf8, 0xf8, 0x0, 0x0, 0x0, 0x8, 0x8, 0x8, 0x10,
0x10, 0x10, 0x18, 0x18, 0x18, 0x20, 0x20, 0x20, 0x28, 0x28, 0x28,
0x30, 0x30, 0x30, 0x38, 0x38, 0x38, 0x40, 0x40, 0x40, 0x48, 0x48,
0x48, 0x50, 0x50, 0x50, 0x58, 0x58, 0x58, 0x60, 0x60, 0x60, 0x68,
0x68, 0x68, 0x70, 0x70, 0x70, 0x78, 0x78, 0x78, 0x80, 0x80, 0x80,
0x88, 0x88, 0x88, 0x90, 0x90, 0x90, 0x98, 0x98, 0x98, 0xa0, 0xa0,
0xa0, 0xa8, 0xa8, 0xa8, 0xb0, 0xb0, 0xb0, 0xb8, 0xb8, 0xb8, 0xc0,
0xc0, 0xc0, 0xc8, 0xc8, 0xc8, 0xd0, 0xd0, 0xd0, 0xd8, 0xd8, 0xd8,
0xe0, 0xe0, 0xe0, 0xe8, 0xe8, 0xe8, 0xf0, 0xf0, 0xf0, 0xf8, 0xf8,
0xf8}, 

/* NoClock = */ 0x5, 

/* FontInfo1 = */ 0x0, 
/* FontInfo2 = */ 0x0, 
/* TextInfo = */ 0x0
}, 

/* DAClong = */ 0x6007cd21, 

/* DACreg = */ {
  0x00, 0x00, 0x00, 0x00, 0xff, 0x1f, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x03, 0x01, 0x09, 0xff, 0xbf, 0x20, 0x1f, 0x20, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x77, 0x04, 0x2d, 0x19, 0x40, 
  0x00, 0xb0, 0x00, 0xc2, 0x34, 0x14, 0x02, 0x83, 
  0x00, 0x93, 0x00, 0x77, 0x71, 0xdb, 0x02, 0x3a, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x03, 0x18, 0x11, 0x00
},

/* ExtVga = */ {0x0, 0x0, 0x0, 0x81, 0x0, 0x0}
} /* end of 1024x768 15bpp array */

#endif /* MODE3 */



};/* end of mode array */
