#! /usr/bin/env python
#
#
#


"""

Generate passwords. Inspired by the kind of passwords you get from sixdegrees.

"""

import  whrandom, string

numpassfragments = 4
passfragments = ['Abba', 'abbe', 'Abby', 'abed', 'Abel', 'abet', 'able', 'ably', 'Abos', 'abut', 'aces', 'ache', 'acid', 'acme', 'acne', 'acre', 'Acta', 'Acts', 'Adam', 'adds', 'Aden', 'afar', 'agar', 'aged', 'Agee', 'ager', 'ages', 'agog', 'ague', 'Aida', 'aide', 'aids', 'aims', 'Ainu', 'airs', 'airy', 'ajar', 'Ajax', 'akin', 'Alan', 'Alar', 'alas', 'alba', 'Alec', 'alee', 'Alex', 'Alfa', 'alga', 'ally', 'alma', 'alms', 'aloe', 'Alps', 'also', 'alum', 'Alva', 'amen', 'Ames', 'amid', 'ammo', 'amok', 'Amos', 'amyl', 'anal', 'Andy', 'anew', 'Anna', 'Anne', 'anon', 'ANSI', 'ante', 'anti', 'ants', 'anus', 'aped', 'apes', 'apex', 'apse', 'aqua', 'Arab', 'arch', 'ARCO', 'arcs', 'area', 'Ares', 'Argo', 'arid', 'arms', 'army', 'ARPA', 'arts', 'Asia', 'asks', 'atom', 'atop', 'aunt', 'aura', 'auto', 'aver', 'avid', 'Avis', 'Aviv', 'Avon', 'avow', 'away', 'awed', 'awls', 'awry', 'axed', 'Axel', 'axer', 'axes', 'axis', 'axle', 'axon', 'ayes', 'babe', 'baby', 'Bach', 'back', 'bade', 'bags', 'bail', 'bait', 'Baja', 'bake', 'Baku', 'bald', 'bale', 'Bali', 'balk', 'ball', 'balm', 'band', 'bane', 'bang', 'bank', 'bans', 'barb', 'bard', 'bare', 'bark', 'barn', 'Barr', 'bars', 'Bart', 'base', 'bash', 'bask', 'bass', 'bath', 'bats', 'baud', 'bawl', 'bays', 'bead', 'beak', 'beam', 'bean', 'bear', 'beat', 'beau', 'beck', 'beds', 'beef', 'been', 'beep', 'beer', 'bees', 'beet', 'begs', 'Bela', 'bell', 'belt', 'bely', 'bend', 'bent', 'Benz', 'Bern', 'Bert', 'Bess', 'best', 'beta', 'bets', 'bevy', 'bias', 'bibs', 'bide', 'bids', 'Bien', 'bier', 'bike', 'bile', 'bilk', 'bill', 'bind', 'bing', 'Bini', 'bins', 'bird', 'bite', 'bits', 'blab', 'bled', 'blew', 'blip', 'blob', 'bloc', 'blot', 'blow', 'blue', 'Blum', 'blur', 'boar', 'boat', 'bobs', 'Boca', 'bode', 'body', 'Boer', 'bogs', 'Bohr', 'boil', 'Bois', 'bold', 'boll', 'bolt', 'bomb', 'bond', 'bone', 'bong', 'Bonn', 'bony', 'boob', 'book', 'boom', 'boon', 'boor', 'boos', 'boot', 'bore', 'Borg', 'born', 'Bose', 'boss', 'both', 'bout', 'bowl', 'bows', 'Boyd', 'boys', 'brae', 'brag', 'bran', 'bras', 'brat', 'bray', 'bred', 'brew', 'Brie', 'brig', 'brim', 'brow', 'Bryn', 'buck', 'Budd', 'buds', 'buff', 'bugs', 'bulb', 'bulk', 'bull', 'bump', 'bums', 'bunk', 'buns', 'bunt', 'buoy', 'burl', 'burn', 'burp', 'Burr', 'Burt', 'bury', 'bush', 'buss', 'bust', 'busy', 'butt', 'buys', 'buzz', 'Byrd', 'byte', 'cabs', 'Cady', 'cafe', 'cage', 'Cain', 'cake', 'calf', 'call', 'calm', 'came', 'camp', 'cane', 'cans', 'cant', 'cape', 'caps', 'card', 'care', 'Carl', 'carp', 'Carr', 'cars', 'cart', 'case', 'cash', 'cask', 'cast', 'cats', 'cave', 'cede', 'cell', 'Celt', 'cent', 'CERN', 'Chad', 'Chao', 'chap', 'char', 'chat', 'chef', 'Chen', 'chew', 'chic', 'chin', 'chip', 'chit', 'chop', 'Chou', 'chum', 'cite', 'city', 'clad', 'clam', 'clan', 'clap', 'claw', 'clay', 'Clio', 'clip', 'clod', 'clog', 'clot', 'club', 'clue', 'Cluj', 'coal', 'coat', 'coax', 'Cobb', 'coca', 'cock', 'coco', 'code', 'Cody', 'coed', 'cogs', 'Cohn', 'coil', 'coin', 'coke', 'cold', 'Cole', 'colt', 'comb', 'come', 'cone', 'cook', 'cool', 'coon', 'coop', 'cope', 'cops', 'copy', 'cord', 'core', 'cork', 'corn', 'cost', 'cosy', 'cots', 'cove', 'cowl', 'cows', 'cozy', 'crab', 'crag', 'cram', 'Cray', 'Cree', 'crew', 'crib', 'crop', 'crow', 'crud', 'crux', 'Cruz', 'Cuba', 'cube', 'cubs', 'cued', 'cues', 'cuff', 'cull', 'cult', 'cups', 'curb', 'curd', 'cure', 'curl', 'curs', 'curt', 'cusp', 'cute', 'cuts', 'cyst', 'czar', 'Dada', 'Dade', 'dads', 'Dahl', 'dale', 'Dali', 'Daly', 'dame', 'damn', 'damp', 'dams', 'Dana', 'Dane', 'dare', 'dark', 'darn', 'dart', 'dash', 'data', 'date', 'Dave', 'Davy', 'dawn', 'days', 'daze', 'dead', 'deaf', 'deal', 'dean', 'dear', 'debt', 'deck', 'deed', 'deem', 'deep', 'deer', 'defy', 'dell', 'demo', 'dens', 'dent', 'deny', 'desk', 'deus', 'dewy', 'dial', 'dice', 'Dido', 'died', 'diem', 'dies', 'diet', 'digs', 'dike', 'dill', 'dime', 'dims', 'dine', 'ding', 'dint', 'Dion', 'dips', 'dire', 'dirt', 'disc', 'dish', 'disk', 'dive', 'dock', 'Dodd', 'doer', 'does', 'Doge', 'dogs', 'dole', 'doll', 'dome', 'done', 'dons', 'doom', 'door', 'dope', 'Dora', 'dose', 'dote', 'dots', 'Doug', 'dove', 'down', 'doze', 'drab', 'drag', 'dram', 'draw', 'drew', 'drip', 'drop', 'drug', 'drum', 'dual', 'dubs', 'duck', 'duct', 'duel', 'dues', 'duet', 'duke', 'dull', 'duly', 'dumb', 'dump', 'dune', 'dung', 'dunk', 'Dunn', 'dupe', 'dusk', 'dust', 'duty', 'dyad', 'dyed', 'dyer', 'dyes', 'Dyke', 'dyne', 'each', 'earl', 'earn', 'Earp', 'ears', 'ease', 'east', 'easy', 'eats', 'ebbs', 'Eben', 'echo', 'eddy', 'Eden', 'edge', 'edit', 'Edna', 'eels', 'Egan', 'eggs', 'egos', 'Eire', 'eked', 'ekes', 'Elba', 'elks', 'Ella', 'elms', 'else', 'Emil', 'emit', 'Emma', 'ends', 'Enid', 'Enos', 'envy', 'epic', 'eras', 'ergo', 'Eric', 'Erie', 'Erik', 'Eris', 'Erne', 'Eros', 'errs', 'espy', 'etch', 'even', 'ever', 'evil', 'Ewen', 'ewes', 'exam', 'exec', 'exit', 'eyed', 'eyer', 'eyes', 'Ezra', 'face', 'fact', 'fade', 'fags', 'fail', 'fain', 'fair', 'fake', 'Falk', 'fall', 'fame', 'fang', 'fans', 'fare', 'farm', 'fast', 'fate', 'fats', 'faun', 'fawn', 'faze', 'fear', 'feat', 'feed', 'feel', 'fees', 'feet', 'fell', 'felt', 'fend', 'fern', 'Fess', 'feud', 'fiat', 'fief', 'fife', 'figs', 'Fiji', 'file', 'fill', 'film', 'find', 'fine', 'fink', 'Finn', 'fins', 'fire', 'firm', 'fish', 'Fisk', 'fist', 'fits', 'five', 'flag', 'flak', 'flam', 'flap', 'flat', 'flaw', 'flax', 'flea', 'fled', 'flee', 'flew', 'flex', 'flip', 'flit', 'flog', 'flop', 'flow', 'flue', 'flux', 'foal', 'foam', 'foci', 'foes', 'fogs', 'fogy', 'foil', 'fold', 'folk', 'fond', 'font', 'food', 'fool', 'foot', 'ford', 'fore', 'fork', 'form', 'fort', 'Foss', 'foul', 'four', 'fowl', 'Fran', 'Frau', 'fray', 'Fred', 'free', 'fret', 'Frey', 'frog', 'from', 'Frye', 'fuel', 'Fuji', 'full', 'fume', 'fund', 'funk', 'furs', 'fury', 'fuse', 'fuss', 'fuzz', 'gags', 'Gail', 'gain', 'gait', 'gale', 'gall', 'Galt', 'game', 'gang', 'gape', 'gaps', 'garb', 'Gary', 'gash', 'gasp', 'gate', 'Gaul', 'gave', 'gawk', 'gaze', 'gear', 'geld', 'gels', 'gems', 'gene', 'gent', 'germ', 'gets', 'gift', 'gild', 'gill', 'gilt', 'Gina', 'Ginn', 'Gino', 'gins', 'gird', 'girl', 'girt', 'gist', 'give', 'glad', 'glee', 'glen', 'glow', 'glue', 'glut', 'gnat', 'gnaw', 'goad', 'goal', 'goat', 'Gobi', 'gods', 'goes', 'Goff', 'Gogh', 'gold', 'golf', 'gone', 'gong', 'good', 'goof', 'gore', 'gory', 'gosh', 'GOTO', 'gout', 'gown', 'grab', 'grad', 'gram', 'gray', 'Greg', 'grew', 'grey', 'grid', 'grim', 'grin', 'grip', 'Gris', 'grit', 'grow', 'grub', 'Guam', 'gulf', 'gull', 'gulp', 'gums', 'guns', 'guru', 'gush', 'gust', 'guts', 'guys', 'Gwen', 'Gwyn', 'gyro', 'Haag', 'Haas', 'hack', 'Hahn', 'hail', 'hair', 'hale', 'half', 'hall', 'halt', 'hams', 'hand', 'hang', 'Hans', 'hard', 'hare', 'hark', 'harm', 'harp', 'hart', 'hash', 'hate', 'hats', 'haul', 'have', 'hawk', 'Hays', 'haze', 'hazy', 'head', 'heal', 'heap', 'hear', 'heat', 'Hebe', 'heck', 'heed', 'heel', 'heir', 'held', 'hell', 'helm', 'help', 'hemp', 'hems', 'hens', 'Hera', 'herb', 'herd', 'here', 'hero', 'Herr', 'hers', 'Hess', 'hews', 'hick', 'hide', 'high', 'hike', 'hill', 'hilt', 'hind', 'hint', 'hips', 'hire', 'hiss', 'hits', 'hive', 'hoar', 'hoes', 'Hoff', 'hogs', 'hold', 'hole', 'Holm', 'holy', 'home', 'homo', 'hone', 'hood', 'hoof', 'hook', 'hoop', 'hoot', 'hope', 'Hopi', 'hops', 'horn', 'hose', 'host', 'hour', 'Howe', 'howl', 'Hoyt', 'hubs', 'Huck', 'hues', 'Huey', 'huge', 'Hugh', 'Hugo', 'hull', 'Hume', 'hump', 'hums', 'hung', 'hunk', 'Huns', 'hunt', 'Hurd', 'hurl', 'hurt', 'hush', 'husk', 'huts', 'Hyde', 'hymn', 'ibex', 'ibid', 'ibis', 'iced', 'ices', 'icon', 'idea', 'idem', 'idle', 'idly', 'idol', 'Ifni', 'Igor', 'ills', 'illy', 'imps', 'Inca', 'inch', 'Indo', 'Indy', 'inks', 'inns', 'into', 'ions', 'iota', 'Iowa', 'Iran', 'Iraq', 'ires', 'iris', 'irks', 'Irma', 'iron', 'Isis', 'isle', 'itch', 'Itel', 'item', 'Ivan', 'jabs', 'jack', 'jade', 'jail', 'Jake', 'jams', 'Jane', 'jars', 'Java', 'jaws', 'jazz', 'jean', 'jeep', 'jeer', 'Jeff', 'jerk', 'jest', 'jets', 'Jews', 'jigs', 'Jill', 'Joan', 'jobs', 'Jody', 'Joel', 'Joes', 'jogs', 'John', 'join', 'joke', 'jolt', 'Jose', 'jots', 'Jove', 'joys', 'Juan', 'Judd', 'Jude', 'judo', 'Judy', 'jugs', 'July', 'jump', 'June', 'Jung', 'junk', 'Juno', 'Jura', 'jure', 'jury', 'just', 'Kahn', 'Kali', 'Kane', 'Kant', 'Karl', 'Karp', 'Kate', 'Katz', 'keel', 'keen', 'keep', 'Kemp', 'Kent', 'kept', 'kern', 'Kerr', 'keys', 'kick', 'kids', 'Kiel', 'Kiev', 'kill', 'kind', 'king', 'kink', 'Kirk', 'kiss', 'kite', 'kits', 'Klan', 'Klux', 'knee', 'knew', 'knit', 'knob', 'knot', 'know', 'Knox', 'Koch', 'Kong', 'kudo', 'Kuhn', 'Kurd', 'Kurt', 'labs', 'lace', 'lack', 'lacy', 'lads', 'lady', 'lags', 'laid', 'lain', 'lair', 'lake', 'lamb', 'lame', 'lamp', 'Lana', 'land', 'lane', 'Lang', 'Laos', 'laps', 'lard', 'lark', 'Lars', 'lash', 'lass', 'last', 'late', 'Laue', 'lava', 'lawn', 'laws', 'lays', 'lazy', 'lead', 'leaf', 'leak', 'lean', 'leap', 'Lear', 'leek', 'leer', 'lees', 'left', 'legs', 'Lena', 'lend', 'lens', 'lent', 'Leon', 'less', 'lest', 'lets', 'Levi', 'levy', 'lewd', 'liar', 'lice', 'lick', 'lids', 'lied', 'lien', 'lies', 'lieu', 'life', 'lift', 'like', 'Lila', 'lily', 'Lima', 'limb', 'lime', 'limp', 'Lind', 'line', 'link', 'lint', 'lion', 'lips', 'Lisa', 'Lise', 'lisp', 'Liss', 'list', 'live', 'load', 'loaf', 'loan', 'lobe', 'loci', 'lock', 'Loeb', 'loft', 'logo', 'logs', 'loin', 'Lois', 'Loki', 'Lola', 'Lomb', 'Lome', 'lone', 'long', 'look', 'loom', 'loon', 'loop', 'loot', 'lord', 'lore', 'lose', 'loss', 'lost', 'lots', 'loud', 'lout', 'love', 'Lowe', 'lows', 'luck', 'Lucy', 'Luis', 'Luke', 'lull', 'lump', 'Lund', 'lung', 'Lura', 'lure', 'lurk', 'lush', 'lust', 'lute', 'Lutz', 'Lyle', 'Lynn', 'lynx', 'Lyon', 'Lyra', 'lyre', 'mace', 'Mach', 'made', 'maid', 'mail', 'maim', 'main', 'make', 'male', 'Mali', 'mall', 'malt', 'mama', 'mane', 'Mann', 'Mans', 'many', 'maps', 'Marc', 'mare', 'mark', 'Mars', 'mart', 'Marx', 'Mary', 'mash', 'mask', 'mass', 'mast', 'mate', 'math', 'mats', 'Matt', 'maul', 'Mawr', 'Maya', 'Mayo', 'maze', 'mead', 'meal', 'mean', 'meat', 'meek', 'meet', 'melt', 'memo', 'mend', 'mens', 'menu', 'mere', 'mesh', 'mess', 'meta', 'mete', 'mets', 'mews', 'mica', 'mice', 'Mick', 'mien', 'mike', 'mild', 'mile', 'milk', 'mill', 'Mimi', 'mind', 'mine', 'mini', 'mink', 'mint', 'MIPS', 'Mira', 'mire', 'miss', 'mist', 'moan', 'moat', 'mobs', 'mock', 'mode', 'Moen', 'Mohr', 'mold', 'mole', 'Moll', 'Mona', 'monk', 'Mont', 'mood', 'Moon', 'Moor', 'moot', 'mops', 'more', 'morn', 'moss', 'most', 'moth', 'move', 'mows', 'much', 'muck', 'Mudd', 'muff', 'mugs', 'Muir', 'mule', 'mull', 'mung', 'muse', 'mush', 'musk', 'must', 'mute', 'mutt', 'Muzo', 'Myra', 'myth', 'nags', 'Nagy', 'nail', 'Nair', 'name', 'naps', 'nary', 'NASA', 'Nash', 'Nate', 'NATO', 'Naur', 'navy', 'Nazi', 'Neal', 'near', 'neat', 'neck', 'need', 'Neff', 'Neil', 'Nell', 'neon', 'Nero', 'Ness', 'nest', 'nets', 'Neva', 'NeWS', 'newt', 'next', 'nice', 'nick', 'nigh', 'Nile', 'Nina', 'nine', 'nips', 'Noah', 'node', 'nods', 'Noel', 'Noll', 'none', 'nook', 'noon', 'Nora', 'norm', 'nose', 'note', 'noun', 'nude', 'null', 'numb', 'nuns', 'nuts', 'oaks', 'oars', 'oath', 'oats', 'obey', 'oboe', 'odds', 'odes', 'Odin', 'odor', 'offs', 'Ohio', 'oils', 'oily', 'okay', 'Olaf', 'Olav', 'oldy', 'Oleg', 'Olga', 'Olin', 'Oman', 'omen', 'omit', 'once', 'ones', 'only', 'onto', 'onus', 'onyx', 'ooze', 'opal', 'OPEC', 'Opel', 'open', 'opts', 'opus', 'oral', 'ores', 'orgy', 'Orin', 'Orly', 'Oslo', 'Otis', 'Otto', 'ouch', 'ours', 'oust', 'outs', 'oval', 'oven', 'over', 'Ovid', 'owed', 'Owen', 'owes', 'owls', 'owns', 'oxen', 'pace', 'pack', 'pact', 'pads', 'page', 'paid', 'pail', 'pain', 'pair', 'pale', 'pall', 'palm', 'Palo', 'pals', 'pane', 'pang', 'pans', 'pant', 'papa', 'PARC', 'pare', 'park', 'Parr', 'pars', 'part', 'Paso', 'pass', 'past', 'pate', 'path', 'pats', 'Paul', 'pave', 'pawn', 'paws', 'pays', 'peak', 'peal', 'pear', 'peas', 'peat', 'peck', 'peek', 'peel', 'peep', 'peer', 'pegs', 'pelt', 'pend', 'Penh', 'Penn', 'pens', 'pent', 'perk', 'Peru', 'pest', 'Pete', 'pets', 'pews', 'Phil', 'pica', 'pick', 'Pict', 'pier', 'pies', 'pigs', 'pike', 'pile', 'pill', 'pimp', 'pine', 'ping', 'pink', 'pins', 'pint', 'pion', 'pipe', 'Pisa', 'piss', 'pith', 'pits', 'Pitt', 'pity', 'Pius', 'plan', 'play', 'plea', 'plod', 'plot', 'plow', 'ploy', 'plug', 'plum', 'plus', 'pods', 'poem', 'poet', 'pogo', 'poke', 'pole', 'Polk', 'poll', 'polo', 'pomp', 'pond', 'pong', 'pony', 'pool', 'poor', 'Pope', 'pops', 'pore', 'pork', 'port', 'pose', 'posh', 'post', 'pots', 'pour', 'pout', 'pray', 'prep', 'prey', 'prim', 'prod', 'prop', 'pros', 'prow', 'pubs', 'puff', 'Pugh', 'puke', 'pull', 'pulp', 'puma', 'pump', 'puns', 'punt', 'puny', 'pupa', 'pups', 'pure', 'purr', 'push', 'puss', 'puts', 'putt', 'Pyle', 'pyre', 'quad', 'quay', 'quip', 'quit', 'quiz', 'race', 'rack', 'raft', 'rage', 'rags', 'raid', 'rail', 'rain', 'rake', 'Ramo', 'ramp', 'rams', 'Rand', 'rang', 'rank', 'rant', 'rape', 'raps', 'rapt', 'rare', 'rash', 'rasp', 'rate', 'rats', 'Raul', 'rave', 'rays', 'raze', 'read', 'real', 'ream', 'reap', 'rear', 'redo', 'reds', 'reed', 'reef', 'reel', 'Reid', 'rein', 'rely', 'Remy', 'Rena', 'rend', 'Rene', 'Reno', 'rent', 'rest', 'Reub', 'Rhea', 'ribs', 'Rica', 'rice', 'rich', 'Rick', 'Rico', 'ride', 'rids', 'rift', 'Riga', 'rigs', 'rill', 'rime', 'rims', 'rind', 'ring', 'rink', 'riot', 'ripe', 'rips', 'RISC', 'rise', 'risk', 'rite', 'Ritz', 'road', 'roam', 'roar', 'robe', 'robs', 'rock', 'rode', 'rods', 'role', 'roll', 'Rome', 'romp', 'roof', 'rook', 'room', 'root', 'rope', 'Rosa', 'Rose', 'Ross', 'rosy', 'Roth', 'rots', 'rout', 'rove', 'Rowe', 'rows', 'Roxy', 'Rube', 'rubs', 'ruby', 'rude', 'Rudy', 'rugs', 'ruin', 'rule', 'rump', 'rung', 'runs', 'runt', 'rush', 'Russ', 'rust', 'Ruth', 'ruts', 'Ryan', 'sack', 'safe', 'saga', 'sage', 'sags', 'said', 'sail', 'sake', 'sale', 'Salk', 'salt', 'Salz', 'same', 'Sana', 'sand', 'sane', 'sang', 'sank', 'saps', 'Sara', 'sari', 'sash', 'sate', 'Saud', 'Saul', 'save', 'saws', 'says', 'scab', 'scan', 'scar', 'Scot', 'scow', 'scud', 'seal', 'seam', 'Sean', 'sear', 'seas', 'seat', 'sect', 'seed', 'seek', 'seem', 'seen', 'seep', 'seer', 'sees', 'self', 'sell', 'semi', 'send', 'sent', 'sept', 'serf', 'Seth', 'sets', 'sews', 'sexy', 'sham', 'Shea', 'shed', 'shin', 'ship', 'shit', 'shod', 'shoe', 'shop', 'shot', 'show', 'shun', 'shut', 'Siam', 'Sian', 'sick', 'side', 'sift', 'sigh', 'sign', 'Sikh', 'silk', 'sill', 'silo', 'silt', 'Sims', 'sine', 'sing', 'sink', 'sins', 'sips', 'sire', 'sirs', 'site', 'sits', 'situ', 'Siva', 'size', 'skew', 'skid', 'skim', 'skin', 'skip', 'skis', 'skit', 'Skye', 'slab', 'slam', 'slap', 'slat', 'Slav', 'slay', 'sled', 'slew', 'slid', 'slim', 'slip', 'slit', 'slob', 'slop', 'slot', 'slow', 'slug', 'slum', 'slur', 'smog', 'smug', 'smut', 'snag', 'snap', 'snip', 'snob', 'snow', 'snub', 'snug', 'soak', 'soap', 'soar', 'sobs', 'sock', 'soda', 'sods', 'sofa', 'soft', 'soil', 'sold', 'sole', 'solo', 'some', 'song', 'sons', 'Sony', 'soon', 'soot', 'sore', 'sort', 'soul', 'soup', 'sour', 'sown', 'soya', 'span', 'spat', 'spec', 'sped', 'spin', 'spit', 'spot', 'spun', 'spur', 'stab', 'stag', 'Stan', 'star', 'stay', 'stem', 'step', 'stew', 'stir', 'stop', 'stow', 'stub', 'stud', 'stun', 'Styx', 'subs', 'such', 'suck', 'suds', 'sued', 'sues', 'Suez', 'suit', 'sulk', 'sums', 'sung', 'sunk', 'suns', 'sure', 'surf', 'swab', 'swam', 'swan', 'swap', 'swat', 'sway', 'swim', 'swum', 'tabs', 'tack', 'tact', 'Taft', 'tags', 'tail', 'take', 'tale', 'talk', 'tall', 'tame', 'tang', 'tank', 'Taos', 'tape', 'taps', 'Tara', 'tart', 'task', 'Tass', 'Tate', 'taut', 'taxi', 'team', 'tear', 'teas', 'teem', 'teen', 'tell', 'tend', 'tens', 'tent', 'term', 'Tess', 'test', 'text', 'Thai', 'than', 'that', 'thaw', 'Thea', 'them', 'then', 'they', 'thin', 'this', 'Thor', 'thud', 'thug', 'thus', 'tick', 'tide', 'tidy', 'tied', 'tier', 'ties', 'tile', 'till', 'tilt', 'time', 'Tims', 'Tina', 'tins', 'tint', 'tiny', 'tips', 'tire', 'Tito', 'tits', 'toad', 'Toby', 'Todd', 'toes', 'Togo', 'toil', 'told', 'toll', 'tomb', 'tone', 'Toni', 'tons', 'took', 'tool', 'tops', 'tore', 'torn', 'Tory', 'toss', 'Toto', 'tour', 'town', 'toys', 'trap', 'tray', 'tree', 'trek', 'trim', 'trio', 'trip', 'trod', 'trot', 'Troy', 'true', 'Truk', 'tube', 'tubs', 'tuck', 'tuft', 'tugs', 'tune', 'turf', 'turn', 'twas', 'twig', 'twin', 'twos', 'type', 'typo', 'ugly', 'Ulan', 'undo', 'unit', 'UNIX', 'Unix', 'unto', 'upon', 'Urdu', 'urge', 'Uris', 'urns', 'Ursa', 'used', 'user', 'uses', 'Utah', 'Vail', 'vain', 'vale', 'vane', 'vans', 'vary', 'vase', 'vast', 'vats', 'veal', 'Veda', 'veer', 'Vega', 'veil', 'vein', 'Vela', 'Venn', 'vent', 'Vera', 'verb', 'Vern', 'very', 'vest', 'veto', 'vial', 'vice', 'Vida', 'vied', 'vier', 'vies', 'Viet', 'view', 'vile', 'vine', 'visa', 'vita', 'Vito', 'void', 'volt', 'Voss', 'vote', 'vows', 'Waco', 'wade', 'waft', 'wage', 'wags', 'Wahl', 'wail', 'wait', 'wake', 'walk', 'wall', 'Walt', 'wand', 'wane', 'Wang', 'want', 'ward', 'ware', 'warm', 'warn', 'warp', 'wars', 'wart', 'wary', 'wash', 'wasp', 'wave', 'waxy', 'ways', 'weak', 'wean', 'wear', 'Webb', 'webs', 'weds', 'weed', 'week', 'weep', 'Wehr', 'weld', 'well', 'went', 'wept', 'were', 'west', 'wets', 'what', 'when', 'whim', 'whip', 'whit', 'whiz', 'whom', 'wick', 'wide', 'Wier', 'wife', 'wigs', 'wild', 'wile', 'will', 'wilt', 'wily', 'wind', 'wine', 'wing', 'wink', 'wins', 'wipe', 'wire', 'wiry', 'wise', 'wish', 'wisp', 'with', 'wits', 'Witt', 'woke', 'wolf', 'womb', 'Wong', 'wont', 'wood', 'woof', 'wool', 'woos', 'word', 'wore', 'work', 'worm', 'worn', 'wove', 'wrap', 'wren', 'writ', 'Wynn', 'Yagi', 'Yale', 'yank', 'yard', 'yarn', 'yawn', 'year', 'yeas', 'yell', 'yelp', 'yoke', 'York', 'Yost', 'your', 'Yuba', 'Yuki', 'Yuri', 'Yves', 'zeal', 'zero', 'zest', 'Zeus', 'zinc', 'Zion', 'zone', 'zoom', 'zoos', 'Zorn', 'Zulu']


def genpassword():
    generator = whrandom.whrandom()
    password = ''
    for i in range(numpassfragments):
        fragment = generator.choice(passfragments)
        fragment = string.upper(fragment[0]) + fragment[1:]
        password = password + fragment
    return password
